import { WebSocketBridgeCommunication } from './WebSocketBridgeCommunication';
import { CompositionModel } from './xcomponentMessages';
import { Session } from '../interfaces/Session';
import { Connection } from '../interfaces/Connection';
export declare class WebSocketConnection implements Connection {
    private webSocket;
    private webSocketBridgeCommunication;
    private sessions;
    closedByUser: boolean;
    constructor(webSocket: WebSocket, webSocketBridgeCommunication: WebSocketBridgeCommunication);
    getXcApiList(): Promise<Array<string>>;
    getCompositionModel(xcApiName: string): Promise<CompositionModel>;
    createSession(apiName: string): Promise<Session>;
    createAuthenticatedSession(apiName: string, sessionData: string): Promise<Session>;
    dispose(): void;
    private initConnection;
}
