import { ApiConfiguration } from '../configuration/apiConfiguration';
import { JsonMessage } from './xcomponentMessages';
import { StateMachineRef } from '../interfaces/StateMachineRef';
import { PrivateTopics } from '../interfaces/PrivateTopics';
import { WebSocketWrapper } from './WebSocketWrapper';
export declare class WebSocketPublisher {
    private webSocketWrapper;
    private configuration;
    private privateTopics;
    sessionData?: string | undefined;
    private serializer;
    constructor(webSocketWrapper: WebSocketWrapper, configuration: ApiConfiguration, privateTopics: PrivateTopics, sessionData?: string | undefined);
    send(componentName: string, stateMachineName: string, messageType: string, jsonMessage: JsonMessage, visibilityPrivate?: boolean, specifiedPrivateTopic?: string): void;
    sendWithStateMachineRef(stateMachineRef: StateMachineRef, messageType: string, jsonMessage: JsonMessage, visibilityPrivate?: boolean, specifiedPrivateTopic?: string): void;
    canSend(componentName: string, stateMachineName: string, messageType: string): boolean;
    private getDataToSend;
    private getHeaderConfig;
    private getRoutingKey;
    private getDataToSendWithStateMachineRef;
}
