import { ApiConfiguration } from '../configuration/apiConfiguration';
import { Session } from '../interfaces/Session';
import { PrivateTopics } from '../interfaces/PrivateTopics';
import { StateMachineUpdateListener } from '../interfaces/StateMachineUpdateListener';
import { StateMachineInstance } from '../interfaces/StateMachineInstance';
import { Observable } from 'rxjs';
import { WebSocketWrapper } from './WebSocketWrapper';
import { JsonMessage } from './xcomponentMessages';
export declare class WebSocketSession implements Session {
    private publisher;
    private subscriber;
    privateTopics: PrivateTopics;
    constructor(webSocketWrapper: WebSocketWrapper, configuration: ApiConfiguration, sessionData?: string);
    send(componentName: string, stateMachineName: string, messageType: string, jsonMessage: JsonMessage, visibilityPrivate?: boolean, specifiedPrivateTopic?: string): void;
    canSend(componentName: string, stateMachineName: string, messageType: string): boolean;
    getSnapshot(componentName: string, stateMachineName: string): Promise<Array<StateMachineInstance>>;
    getStateMachineUpdates(componentName: string, stateMachineName: string): Observable<StateMachineInstance>;
    subscribe(componentName: string, stateMachineName: string, stateMachineUpdateListener: StateMachineUpdateListener): void;
    unsubscribe(componentName: string, stateMachineName: string): void;
    canSubscribe(componentName: string, stateMachineName: string): boolean;
    dispose(): void;
}
