import { Observable } from 'rxjs';
import { ApiConfiguration } from '../configuration/apiConfiguration';
import 'rxjs/add/operator/toPromise';
import { WebSocketPublisher } from './WebSocketPublisher';
import { PrivateTopics } from '../interfaces/PrivateTopics';
import { StateMachineInstance } from '../interfaces/StateMachineInstance';
import { StateMachineUpdateListener } from '../interfaces/StateMachineUpdateListener';
import { WebSocketWrapper } from './WebSocketWrapper';
export declare class WebSocketSubscriber {
    private webSocketWrapper;
    private configuration;
    private stateMachineRefSendPublisher;
    private subscribedStateMachines;
    private updates$;
    private deserializer;
    private serializer;
    private timeout;
    constructor(webSocketWrapper: WebSocketWrapper, configuration: ApiConfiguration);
    setStateMachineRefSendPublisher(stateMachineRefSendPublisher: WebSocketPublisher): void;
    getSnapshot(componentName: string, stateMachineName: string, privateTopics: PrivateTopics): Promise<Array<StateMachineInstance>>;
    private getDataToSendSnapshot;
    private prepareStateMachineUpdates;
    private isSameComponent;
    private isSameStateMachine;
    getStateMachineUpdates(componentName: string, stateMachineName: string): Observable<StateMachineInstance>;
    canSubscribe(componentName: string, stateMachineName: string): boolean;
    subscribe(componentName: string, stateMachineName: string, stateMachineUpdateListener: StateMachineUpdateListener): void;
    private sendSubscribeRequest;
    sendSubscribeRequestToTopic(topic: string, kind: number): void;
    sendUnsubscribeRequestToTopic(topic: string, kind: number): void;
    private getDataToSend;
    unsubscribe(componentName: string, stateMachineName: string): void;
    private isSubscribed;
    private addSubscribedStateMachines;
    private removeSubscribedStateMachines;
    getJsonDataFromSnapshot(data: string, topic?: string): Array<StateMachineInstance>;
    getJsonDataFromEvent(data: string, topic?: string): StateMachineInstance;
    private getStateMachineRef;
}
