import { ParsedApiConfiguration } from './parsedApiConfigurationTypes';
export interface PublisherDetails {
    eventCode: number;
    routingKey: string;
}
export declare enum SubscriberEventType {
    Update = 0,
    Error = 1
}
export interface ApiConfiguration {
    getComponentCode(componentName: string): number;
    containsComponent(componentName: string): boolean;
    getStateMachineCode(componentName: string, stateMachineName: string): number;
    containsStateMachine(componentName: string, stateMachineName: string): boolean;
    getPublisherDetails(componentCode: number, stateMachineCode: number, messageType: string): PublisherDetails;
    getSubscriberTopic(componentCode: number, stateMachineCode: number, type: SubscriberEventType): string;
    getSnapshotTopic(componentCode: number): string;
    getStateName(componentCode: number, stateMachineCode: number, stateCode: number): string;
    containsPublisher(componentCode: number, stateMachineCode: number, messageType: string): boolean;
    containsSubscriber(componentCode: number, stateMachineCode: number, type: SubscriberEventType): boolean;
}
export declare class DefaultApiConfiguration implements ApiConfiguration {
    private _config;
    constructor(rawConfig: ParsedApiConfiguration);
    private validate;
    getComponentCode(componentName: string): number;
    getStateMachineCode(componentName: string, stateMachineName: string): number;
    private findStateMachineByName;
    private findStateMachineByCode;
    private findStateByCode;
    private findComponentByName;
    private findComponentByCode;
    private findComponent;
    private findStateMachine;
    containsComponent(componentName: string): boolean;
    containsStateMachine(componentName: string, stateMachineName: string): boolean;
    containsPublisher(componentCode: number, stateMachineCode: number, messageType: string): boolean;
    containsSubscriber(componentCode: number, stateMachineCode: number, type: SubscriberEventType): boolean;
    getPublisherDetails(componentCode: number, stateMachineCode: number, messageType: string): PublisherDetails;
    private getPublisher;
    getSubscriberTopic(componentCode: number, stateMachineCode: number, type: SubscriberEventType): string;
    private getSubscriber;
    getSnapshotTopic(componentCode: number): string;
    getStateName(componentCode: number, stateMachineCode: number, stateCode: number): string;
}
