function xmlNodeToJson(node) {
    var _a;
    var obj = { _: '' };
    // Attributs
    for (var _i = 0, _b = Array.from(node.attributes); _i < _b.length; _i++) {
        var attr = _b[_i];
        obj[attr.name] = attr.value;
    }
    // Enfants
    for (var _c = 0, _d = Array.from(node.children); _c < _d.length; _c++) {
        var child = _d[_c];
        var tag = child.tagName;
        var childObj = xmlNodeToJson(child);
        if (obj[tag]) {
            if (!Array.isArray(obj[tag])) {
                obj[tag] = [obj[tag]];
            }
            obj[tag].push(childObj);
        }
        else {
            obj[tag] = childObj;
        }
    }
    // Texte
    var text = (_a = node.textContent) === null || _a === void 0 ? void 0 : _a.trim();
    if (text && node.children.length === 0) {
        obj._ = text;
    }
    return obj;
}
export function parseXmlToJson(xml) {
    var _a;
    var parser = new DOMParser();
    var doc = parser.parseFromString(xml, 'application/xml');
    var errorNode = doc.querySelector('parsererror');
    if (errorNode) {
        throw new Error('Invalid XML');
    }
    ;
    var root = doc.documentElement;
    var result = (_a = {}, _a[root.tagName] = xmlNodeToJson(root), _a);
    return result;
}
//# sourceMappingURL=xmlParser.js.map